using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyScript : MonoBehaviour {

    public int shipHP = 2;

    public GameObject ammoGameObject;
    public Transform laserLocation;
    private GameObject[] ammoGameObjectList;

    private float fireTime = 0.0f;
    private float fireTimeInterval = 1.0f;



    private Transform playerObject;

    bool followPlayer = false;
    public float followSpeed = 1.0f;

    // Start is called before the first frame update
    void Start(){


        ammoGameObjectList = new GameObject[5];

        for (int i = 0; i < ammoGameObjectList.Length; i++) {


            ammoGameObjectList[i] = (GameObject)Instantiate(ammoGameObject);
            ammoGameObjectList[i].transform.position = laserLocation.position;
            ammoGameObjectList[i].transform.rotation = laserLocation.rotation;
            ammoGameObjectList[i].SetActive(false);

        }

        playerObject = GameObject.FindGameObjectWithTag("Player").transform;


    }

    // Update is called once per frame
    void Update() {

        if (shipHP == 0) {


            gameObject.SetActive(false);
            shipHP = 2;
        }


        LayerMask lMask = LayerMask.GetMask("Player");

        Debug.DrawRay(transform.position, gameObject.transform.up * 50, Color.white);
        RaycastHit2D rHit2D = Physics2D.Raycast(transform.position, gameObject.transform.up, 50, lMask);

        if(rHit2D.collider != null) {

            //Debug.Log(rHit2D.collider.name);
            //Debug.Log("we hit the player");

            followPlayer = true;

            if (Time.time > fireTime) {

                FireLaser();
                fireTime = fireTimeInterval + Time.time;

                //Debug.Log("You can fire again...");

            }





		}

		if (followPlayer == true) {

            transform.position = Vector2.MoveTowards(transform.position, playerObject.position, followSpeed * Time.deltaTime);

            Vector3 dir = (playerObject.transform.position - gameObject.transform.position);
            Quaternion rot = Quaternion.LookRotation(Vector3.forward, dir);
            transform.rotation = Quaternion.Lerp(transform.rotation, rot, Time.deltaTime * 12.0f);


		} else {

            transform.Rotate(Vector3.forward * 65.0f * Time.deltaTime);

        }


        


    }


    void FireLaser() {


        for (int i = 0; i < ammoGameObjectList.Length; i++) {


            if (ammoGameObjectList[i].activeInHierarchy == false) {

                ammoGameObjectList[i].SetActive(true);
                ammoGameObjectList[i].transform.position = laserLocation.position;
                ammoGameObjectList[i].transform.rotation = laserLocation.rotation;

                break;
            }

        }

    }
     

    private void OnTriggerEnter2D(Collider2D collision) {


        if (collision.gameObject.tag == "PlayerLaser") {

            collision.gameObject.SetActive(false);
            shipHP = shipHP - 1;
            Debug.Log("hit the enemy....");

        }


    }



}
