using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerScript : MonoBehaviour {

    // Start is called before the first frame update

    public int playerHP = 10;

    public GameObject ammoGameObject;
    public Transform laserLocation;
    private GameObject[] ammoGameObjectList;


    private Rigidbody2D rbody2D = null;
    private SpriteRenderer spriteRenderer;


    public float shipForce = 0.2f;

    bool allowedToFire = false;

    private float fireTime = 0.0f;
    private float fireTimeInterval = 0.32f;

    public float rotationSpeed = 0.0f;



    void Start() {

        ammoGameObjectList = new GameObject[5];

        for(int i = 0; i < ammoGameObjectList.Length; i++) {


            ammoGameObjectList[i] = (GameObject)Instantiate(ammoGameObject);
            ammoGameObjectList[i].transform.position = laserLocation.position;
            ammoGameObjectList[i].SetActive(false);

        }

        rbody2D = gameObject.GetComponent<Rigidbody2D>();
        spriteRenderer = gameObject.GetComponent<SpriteRenderer>();

    }

    // Update is called once per frame
    void Update() {

        if(playerHP <= 0) {

            gameObject.SetActive(false);

		}


        transform.Translate(Vector2.up * shipForce * Time.deltaTime);

        if (Input.GetKey(KeyCode.A)) {


            transform.Rotate(Vector3.forward * rotationSpeed * Time.deltaTime);
            //rbody2D.rotation += rotationSpeed * Time.deltaTime;


        }

        if (Input.GetKey(KeyCode.D)) {

            transform.Rotate(Vector3.forward * -rotationSpeed * Time.deltaTime);
            //rbody2D.rotation -= rotationSpeed * Time.deltaTime;

        }


		if (Input.GetKeyDown(KeyCode.Space)) {

			if (allowedToFire == true) {

                if (Time.time > fireTime) {

                    FireLaser();
                    fireTime = fireTimeInterval + Time.time;

                    //Debug.Log("You can fire again...");

                }

            }

        }

    }

    void FixedUpdate() {



    }


    void FireLaser() {


        for(int i = 0; i < ammoGameObjectList.Length; i++) {


            if(ammoGameObjectList[i].activeInHierarchy == false) {

                ammoGameObjectList[i].SetActive(true);
                ammoGameObjectList[i].transform.position = laserLocation.position;
                ammoGameObjectList[i].transform.rotation = laserLocation.rotation;

                break;
			}
            
		}

	}



	private void OnTriggerEnter2D(Collider2D collision) {

        if(collision.gameObject.tag == "Circle") {

            spriteRenderer.color = Color.white;
            allowedToFire = true;
            //Debug.Log("entering the circle....");

		}else if(collision.gameObject.tag == "EnemyLaser") {

            Debug.Log("player was hit  by enemy laser");
            playerHP = playerHP - 2;
            collision.gameObject.SetActive(false);

		}


	}

    private void OnTriggerExit2D(Collider2D collision)
    {

        if (collision.gameObject.tag == "Circle") {

            spriteRenderer.color = Color.blue;
            allowedToFire = false;
            //Debug.Log("exiting the circle....");

        }


    }


}
